﻿Imports System.Printing
Imports PrintQueueMonitor

Public Class Form1

    Private pqm As PrintQueueMonitor.PrintQueueMonitor = Nothing
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim ps As New PrintServer()
        For Each pq As PrintQueue In ps.GetPrintQueues()
            cmbPrinters.Items.Add(pq.Name)
        Next

    End Sub

    Sub pqm_OnJobStatusChange(Sender As Object, e As PrintJobChangeEventArgs)
        Dim invoker As MethodInvoker = Sub()
                                           lbSpoolChanges.Items.Add(String.Format("{0} - {1} - {2}", e.JobID, e.JobName, e.JobStatus.ToString))
                                       End Sub
        If lbSpoolChanges.InvokeRequired Then
            Invoke(invoker)
        Else
            invoker()
        End If

    End Sub

    Private Sub btnMonitor_Click(sender As Object, e As EventArgs) Handles btnMonitor.Click
        If cmbPrinters.Enabled Then
            If cmbPrinters.Text.Trim() = "" Then
                Return
            End If
            pqm = New PrintQueueMonitor.PrintQueueMonitor(cmbPrinters.Text.Trim())
            AddHandler pqm.OnJobStatusChange, AddressOf pqm_OnJobStatusChange
            cmbPrinters.Enabled = False
            btnMonitor.Text = "Stop Monitoring....."
        Else
            If pqm IsNot Nothing Then
                pqm.[Stop]()
            End If
            pqm = Nothing
            cmbPrinters.Enabled = True
            btnMonitor.Text = "Start Monitoring....."
        End If
    End Sub


End Class
